package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesWorkOrderToWmsService;
import cn.estsh.i3plus.platform.common.convert.ConvertBean;
import cn.estsh.i3plus.platform.common.tool.MathOperation;
import cn.estsh.i3plus.pojo.mes.bean.MesBom;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrder;
import cn.estsh.i3plus.pojo.mes.bean.MesWorkOrderToWms;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description : 工单发送给WMS数据
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/6/18 19:58
 * @Modify:
 **/
@Service
@Slf4j
public class MesWorkOrderToWmsServiceImpl extends BaseMesService<MesWorkOrderToWms> implements IMesWorkOrderToWmsService {

    @Override
    public List<MesWorkOrderToWms> saveMesWorkOrderToWms(MesWorkOrder mesWorkOrder, List<MesBom> mesBomList) {
        List<MesWorkOrderToWms> mesWorkOrderToWmsList = new ArrayList<>();
        MesWorkOrderToWms mesWorkOrderToWms = null;
        for (MesBom mesBom : mesBomList) {
            mesWorkOrderToWms = new MesWorkOrderToWms();
            BeanUtils.copyProperties(mesWorkOrder, mesWorkOrderToWms, "id");
            mesWorkOrderToWms.setUnit(mesBom.getUnit());
            mesWorkOrderToWms.setItemPartNo(mesBom.getItemPartNo());
            mesWorkOrderToWms.setItemPartName(mesBom.getItemPartName());
            mesWorkOrderToWms.setItemUnit(mesBom.getItemUnit());
            mesWorkOrderToWms.setItemQty(MathOperation.mul(mesWorkOrder.getQty(), mesBom.getItemQty()));
            ConvertBean.serviceModelInitialize(mesWorkOrderToWms, mesWorkOrderToWms.getCreateUser());
            mesWorkOrderToWmsList.add(mesWorkOrderToWms);
        }
        return mesWorkOrderToWmsList;
    }
}
