package cn.estsh.i3plus.ext.mes.apiservice.utils;

import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.jpa.dao.BaseRepository;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.util.CollectionUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BeanMapUtilsExt {

    public static <T> Map<String, T> getBeanMap(BaseRepository<T, Long> repository, String columnName, String organizeCode, List<String> dataList, String remindMsg) {
        Map<String, T> beanMap = new HashMap();
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(dataList, columnName, packBean);
        DdlPreparedPack.getOrderBy(null,null,packBean);
        List<T> baseDataList = repository.findByHqlWhere(packBean);
        if (!CollectionUtils.isEmpty(baseDataList)) {
            for (T object : baseDataList) {
                try {
                    String keyData = BeanUtils.getProperty(object, columnName);
                    beanMap.put(keyData, object);
                } catch (Exception var11) {
                    MesException.throwMesBusiException(remindMsg + "转换异常");
                }
            }
        } else {
            MesException.throwMesBusiException(remindMsg + "信息不存在");
        }
        return beanMap;
    }

    public static <T> Map<String, T> getBeanMap(BaseRepository<T, Long> repository, String columnName, String organizeCode, List<String> dataList) {
        Map<String, T> beanMap = new HashMap();
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(dataList, columnName, packBean);
        DdlPreparedPack.getOrderBy(null,null,packBean);
        List<T> baseDataList = repository.findByHqlWhere(packBean);
        if (!CollectionUtils.isEmpty(baseDataList)) {
            for (T object : baseDataList) {
                try {
                    String keyData = BeanUtils.getProperty(object, columnName);
                    beanMap.put(keyData, object);
                } catch (Exception var11) {
                    continue;
                }
            }
        }
        return beanMap;
    }

    public static <T> List<T> getBeanList(BaseRepository<T, Long> repository, String columnName, String organizeCode, List<String> dataList, String remindMsg) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(organizeCode);
        DdlPreparedPack.getInPackList(dataList, columnName, packBean);
        DdlPreparedPack.getOrderBy(null,null,packBean);
        List<T> baseDataList = repository.findByHqlWhere(packBean);
        if (CollectionUtils.isEmpty(baseDataList)) {
            MesException.throwMesBusiException(remindMsg + "信息存在");
        }
        return baseDataList;
    }
}
